#ifndef _QTCHESS_
#define _QTCHESS_

/*
** -- Qt Includes --
*/

#include <qapplication.h>

/*
** -- Local Includes --
*/

#include "qtchess_gui.h"
#include "qtchess_comm.h"
#include "qtchess_defs.h"
#include "qtchess_validate.h"

class qtchess
{
 public:

  /*
  ** -- Members --
  */

  int board[NSQUARES][NSQUARES];
  struct move_s last_opponent_move;

  /*
  ** -- Methods --
  */

  qtchess(void)
    {
      int i = 0, j = 0;

      for(i = 0; i < NSQUARES; i++)
	for(j = 0; j < NSQUARES; j++)
	  board[i][j] = 0;

      turn = -1;
      first = -1;
      my_color = -1;
    }

  int getTurn(void)
    {
      return turn;
    }

  int getFirst(void)
    {
      return first;
    }

  int getMyColor(void)
    {
      return my_color;
    }

  int hasKingMoved(void)
    {
      return king_has_moved;
    }

  int hasRook1Moved(void)
    {
      return rook1_has_moved;
    }

  int hasRook2Moved(void)
    {
      return rook2_has_moved;
    }

  struct move_s getLastOpponentMove(void)
    {
      return last_opponent_move;
    }

  void setLastOpponentMove(const struct move_s move)
    {
      last_opponent_move = move;
    };

  void setTurn(const int turn_arg)
    {
      this->turn = turn_arg;
    }

  void setFirst(const int first_arg)
    {
      this->first = first_arg;
    }

  void setMyColor(const int my_color_arg)
    {
      this->my_color = my_color_arg;
    }

  void setKingHasMoved(const int king_has_moved_arg)
    {
      this->king_has_moved = king_has_moved_arg;
    }

  void setRook1HasMoved(const int rook1_has_moved_arg)
    {
      this->rook1_has_moved = rook1_has_moved_arg;
    }

  void setRook2HasMoved(const int rook2_has_moved_arg)
    {
      this->rook2_has_moved = rook2_has_moved_arg;
    }

  int isReady(void);
  int isConnected(void);
  void init(void);
  void quit(const char *, const int);
  void updateBoard(char *);

 private:

  /*
  ** -- Members --
  */

  int turn;
  int first;
  int my_color;
  int king_has_moved;
  int rook1_has_moved;
  int rook2_has_moved;

  /*
  ** -- Methods
  */
};

#endif
