#ifndef _QTCHESS_GUI_OPENGL_
#define _QTCHESS_GUI_OPENGL_

/*
** -- Qt Includes --
*/

#include <qgl.h>
#include <qevent.h>

/*
** -- OpenGL Includes --
*/

extern "C"
{
#include <GL/gl.h>
}

#define KING_X_OFFSET 20
#define KING_Y_OFFSET 10
#define KING_B_WIDTH 42
#define KING_B_HEIGHT 10
#define KING_BT_WIDTH 32
#define KING_BT_HEIGHT 5
#define KING_WIDTH 26
#define KING_HEIGHT 30
#define KING_HCROSS_WIDTH 26
#define KING_HCROSS_HEIGHT 10
#define KING_VCROSS_WIDTH 14
#define KING_VCROSS_HEIGHT 20

#define PAWN_WIDTH 18
#define PAWN_HEIGHT 24
#define PAWN_X_OFFSET 30
#define PAWN_Y_OFFSET 10

#define ROOK_WIDTH 22
#define ROOK_HEIGHT 32
#define ROOK_B_WIDTH 42
#define ROOK_B_HEIGHT 10
#define ROOK_T_WIDTH 32
#define ROOK_T_HEIGHT 20
#define ROOK_X_OFFSET 20
#define ROOK_Y_OFFSET 10

#define QUEEN_X_OFFSET 20
#define QUEEN_Y_OFFSET 10
#define QUEEN_B_WIDTH 42
#define QUEEN_B_HEIGHT 10
#define QUEEN_BT_WIDTH 32
#define QUEEN_BT_HEIGHT 5
#define QUEEN_WIDTH 26
#define QUEEN_HEIGHT 30

#define KNIGHT_WIDTH 42
#define KNIGHT_HEIGHT 64
#define KNIGHT_X_OFFSET 20
#define KNIGHT_Y_OFFSET 10

#define BISHOP_WIDTH 42
#define BISHOP_HEIGHT 64
#define BISHOP_X_OFFSET 20
#define BISHOP_Y_OFFSET 10

/*
** -- Class(es) --
*/

class point
{
 public:

  /*
  ** -- Members --
  */

  int x;
  int y;

  /*
  ** -- Methods --
  */
};

class openglWid: public QGLWidget
{
 public:

  /*
  ** -- Members --
  */

  /*
  ** -- Methods --
  */

  openglWid(QWidget *, const char *);
  void mousePressEvent(QMouseEvent *);
  virtual void paintGL(void);
  virtual void initializeGL(void);
  virtual void resizeGL(int, int);

 private:

  /*
  ** -- Members --
  */

  int p; // Used for centering the board.
  int block_size;
  int mouse_pressed;
  point point_pressed;
  point point_selected;

  /*
  ** -- Methods --
  */
};

#endif
